
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[LeetCode] Convert Sorted List to Binary Search Tree（分治） / 憋错料</title>

    <meta name="description" content="[LeetCode] Convert Sorted List to Binary Search Tree（分治） Given a singly linked list where elements are sorted in ascending order, convert it to a height balanced BST. 方法:为了使BST高度平衡,要找链表中的中值作为当前根节点. /** * Definition for singly-linked list. * struct ListNode { * int val; * ListNode *next; * ListNode(int x) :">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[LeetCode] Convert Sorted List to Binary Search Tree（分治）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Given a singly linked list where elements are sorted in ascending order, convert it to a height balanced BST.</p>
<p>方法：为了使BST高度平衡，要找链表中的中值作为当前根节点。</p>
<pre>/**
 * Definition for singly-linked list.
 * struct ListNode {
 *     int val;
 *     ListNode *next;
 *     ListNode(int x) : val(x), next(NULL) {}
 * };
 */
/**
 * Definition for binary tree
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    TreeNode *sortedListToBST(ListNode *head) {
        if(head==NULL)
            return NULL;
        ListNode *pmid = FindMid(head);
        TreeNode *root = new TreeNode(pmid-&gt;val);
        if(pmid != head)
           root-&gt;left = sortedListToBST(head);
        root-&gt;right = sortedListToBST(pmid-&gt;next);
        return root;
    }
private:
    ListNode *FindMid(ListNode *head){//找中间结点
        if(head-&gt;next==NULL)
            return head;
        ListNode *Pmid=head,*p=head,*Pmin_pre = head;
        while(p!=NULL &amp;&amp; p-&gt;next != NULL)
        {
           p = p-&gt;next;
           p = p-&gt;next;
           Pmin_pre = Pmid;
           Pmid = Pmid-&gt;next;
        }//end while;
        Pmin_pre-&gt;next = NULL;
        return Pmid;
    }
};</pre>
<p><P>[LeetCode] Convert Sorted List to Binary Search Tree（分治）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 20:58:06 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/amp/" title="amp">amp</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[LeetCode] Convert Sorted List to Binary Search Tree（分治）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K29jJM.html" rel="bookmark">&lbrack;leetcode&rsqb;Convert Sorted List to Binary Search Tree &commat; &NewLine;Python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原题地址:http://oj.leetcode.com/problems/convert-sorted-list-to-binary-search-tree/ 题意:将一条排序好的链表转换为二叉查找树,二叉查找树需要平衡. 解题思路:两个思路:一,可以使用快慢指针来找到中间的那个节点,然后将这个节点作为树根,并分别递归这个节点左右两边的链表产生左右子树,这样的好处是不需要使用额外的空间,坏处是代码不够整洁.二,将排序好的链表的每个节点的值存入一个数组中,这样就和http://www.cnblog			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47mKnx0.html" rel="bookmark">&lbrack;leetcode&rsqb;Convert Sorted Array to Binary Search Tree &commat; &NewLine;Python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原题地址:http://oj.leetcode.com/problems/convert-sorted-array-to-binary-search-tree/ 题意:将一个排序好的数组转换为一颗二叉查找树,这颗二叉查找树要求是平衡的. 解题思路:由于要求二叉查找树是平衡的.所以我们可以选在数组的中间那个数当树根root,然后这个数左边的数组为左子树,右边的数组为右子树,分别递归产生左右子树就可以了. 代码: # Definition for a binary tree node # class			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AE8ZZ4.html" rel="bookmark">LeetCode&colon; Convert Sorted List to Binary Search Tree &lbrack;109&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[题目] Given a singly linked list where elements are sorted in ascending order, convert it to a height balanced BST. [题意] 将一个有序链表转换成平衡二叉树 [思路] 思路跟Convert Sorted Array to Binary Search Tree完全一样 [代码] /** * Definition for singly-linked list. * struct List			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzXG6W3.html" rel="bookmark">LeetCode&colon; Convert Sorted Array to Binary Search Tree &lbrack;108&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[题目] Given an array where elements are sorted in ascending order, convert it to a height balanced BST. [题意] 给定一个已排序的数组(不存在重复元素),将它转换成一棵平衡二叉搜索树. [思路] 由于平衡二叉树要求左右子树的高度差绝对值相遇等于1,也就是说左右子树尽可能包含相同数目节点. 则使用二分法来解本题即可. [代码] /** * Definition for binary tree *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e5lva0.html" rel="bookmark">&lbrack;LeetCode&rsqb;  Convert Sorted List to Binary Search Tree 将有序链表转为二叉搜索树</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a singly linked list where elements are sorted in ascending order, convert it to a height balanced BST. 这道题是要求把有序链表转为二叉搜索树,和之前那道Convert Sorted Array to Binary Search Tree 将有序数组转为二叉搜索树思路完全一样,只不过是操作的数据类型有所差别,一个是数组,一个是链表.数组方便就方便在可以通过index直接访问任意一个元			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEYdvQM.html" rel="bookmark">LeetCode&colon; Convert Sorted Array to Binary Search Tree  解题报告</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Convert Sorted Array to Binary Search Tree Given an array where elements are sorted in ascending order, convert it to a height balanced BST.SOLUTION 1:使用递归解决. base case: 当索引值超过时,返回null. 递归主体:构造根节点,调用递归构造左右子树.并将左右子树挂在根节点上. 返回值:返回构造的根节点. GITHUB: https:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3q5YRW3.html" rel="bookmark">&lbrack;Leetcode&rsqb;Convert Sorted Array to Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given an array where elements are sorted in ascending order, convert it to a height balanced BST. 分治是比较好而且容易想到的思路. 1 class Solution { 2 public: 3 TreeNode *mergeAToT(vector&lt;int&gt; &amp;num,int left,int right){ 4 if(left&gt;right) 5 return NULL; 6 int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVwJZy0.html" rel="bookmark">LeetCode&mdash;&mdash;Convert Sorted Array to Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given an array where elements are sorted in ascending order, convert it to a height balanced BST. 原题链接:https://oj.leetcode.com/problems/convert-sorted-array-to-binary-search-tree/ 题目:给定一个升序排列元素的数组,将其转换成高度平衡的二叉树. 思路:已经排序.则从中间劈开,中间元素为树的根,左右递归构建. public			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wyqyVM.html" rel="bookmark">LeetCode&mdash;&mdash;Convert Sorted List to Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a singly linked list where elements are sorted in ascending order, convert it to a height balanced BST. 原题链接:https://oj.leetcode.com/problems/convert-sorted-list-to-binary-search-tree/ 题目:给定一个有正序链表,将其转换成一个二叉搜索树. 思路:能够依照之前的数组的思路来做.即找到中间值.再左右递归建树			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBYKy4.html" rel="bookmark" class="title">Python语法背后的东西&lpar;解释器层面&rpar;</a>
					<div>
						首先,需要强调的一点是Python中一切皆是对象.无论是类似1,'hello',[1,2,3] 类型的序列,还是诸如class Foo, import abs 等类型的类和模块,都是对象.我们碰到的某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMX6wb3.html" rel="bookmark" class="title">Git的学习笔记</a>
					<div>
						1.windows系统下载msysgit软件,一直next安装至完成,然后鼠标右键就能看到Git Bash here 和Git GUI here. 2.在自己建的目录下右击选中Git Bash her ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/N4p2Xo0.html" rel="bookmark" class="title">【转】简明 Vim 练级攻略</a>
					<div>
						原文链接:http://coolshell.cn/articles/5426.html 看完豁然开朗,收藏至此,喜欢的朋友,欢迎去原作者去阅读 原文分割线 ====================== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r59N70.html" rel="bookmark" class="title">How to select a CRAN mirror in R &amp;amp&semi; use repos  parameter&lpar;2&rpar;</a>
					<div>
						首次添加功能包需要设定CRAN镜像库: 方法是依据提示:--- Please select a CRAN mirror for use in this session ---,在弹出的窗口中选择CRA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqqaw0.html" rel="bookmark" class="title">USACO Chapter 1 Section 1&period;3</a>
					<div>
						1 /* 2 ID:xiekeyi1 3 PROG:milk 4 LANG:C++ 5 */ 6 7 #include&lt;bits/stdc++.h&gt; 8 using namespace s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gveP0.html" rel="bookmark" class="title">js把时间戳转换为普通日期格式</a>
					<div>
						第一种 function getLocalTime(nS) { return new Date(parseInt(nS) * 1000).toLocaleString().replace(/:\d{1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRvVJ0.html" rel="bookmark" class="title">iOS开发&mdash;&mdash;图形编程OC篇&amp;amp&semi;（一）Quartz 2D介绍</a>
					<div>
						Quartz 2D介绍 一.什么是Quartz2D Quartz 2D是?个二维绘图引擎,同时支持iOS和Mac系统 Quartz 2D能完成的工作: 绘制图形 : 线条\三角形\矩形\圆\弧等 绘制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K256mM.html" rel="bookmark" class="title">机器学习笔记-监督学习之决策树</a>
					<div>
						0机器学习中分类和预测算法的评估: 准确率 速度 健壮性 可规模性 可解释性 1决策树(判定树)的概念 决策树是一个类似于流程图的树结构(可以是二叉树或多叉树):其中,每个内部结点表示在一个属性上的测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDd1opM.html" rel="bookmark" class="title">kali linux 添加源 及为firefox esr 添加 flash 插件 --2017</a>
					<div>
						终端 输入 vim /etc/apt/sources.list 在文件内写入 #中科大deb http://mirrors.ustc.edu.cn/kali kali-rolling main non ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqkAm4.html" rel="bookmark" class="title">关于setvbuf&lpar;&rpar;函数的详解</a>
					<div>
						为什么要使用setvbuf函数 如果你的内存足够大,可以把文件IO的BUF设置大一些,这样每次你用fopen/fread/fwrite/fscanf/fprintf语句的时候,都会在内存里操作,减少内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylXKj4.html" rel="bookmark" class="title">AngularJS 的安全Apply</a>
					<div>
						$scope.safeApply = function(fn) {     var phase = this.$root.$$phase;     if (phase == '$apply' || p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e77Zp4.html" rel="bookmark" class="title">iOS手势（滑动）返回的实现（自定义返回按钮）</a>
					<div>
						如果各位使用的是storyboard布局的话,且用的是系统的返回按钮,那么是自动会有滑动返回效果的,但是相信各位做项目的,一般都是用的自定义的返回按钮,所以我贴几行代码,看看怎么实现系统自带的滑动返回 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZW1R0.html" rel="bookmark" class="title">UVA 10986&Tab;Sending email 【dijkstra &plus; 堆优化】</a>
					<div>
						题目链接: https://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_proble ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNlA74.html" rel="bookmark" class="title">http服务&lpar;三&rpar;&mdash;&mdash;apache配置个人主页</a>
					<div>
						如果你有心留意一些提供服务器托管的网站,你会发现这些网站都提供一些个人主页空间的服务.也许,你很羡慕他们,以为这是一个很了不起的技术.其实,只要学习,你也可以完成这个项目. 下面,我们就将开始学习怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVznN1M.html" rel="bookmark" class="title">Linux Ext3、Ext4误删文件恢复 extundelete</a>
					<div>
						使用linux难免遇到误删文件的情况,使用extundlete 即可恢复误删文件 记下操作流程:1. 安装Linux数据恢复软件extundelete需要依赖两个包 sudo aptitude ins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RwVEp3.html" rel="bookmark" class="title">Alex 的 Hadoop 菜鸟教程&colon; 第9课 zookeeper 介绍和使用</a>
					<div>
						声明 本文基于Centos 6.x + CDH 5.x zookeeper有什么用 看了之前的教程,会发现多处出现zookeeper,比如hadoop的 auto failover 得用 zookee ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7lxE4.html" rel="bookmark" class="title">《Essential C&plus;&plus;》读书笔记 之 基于对象编程风格</a>
					<div>
						&lt;Essential C++&gt;读书笔记 之 基于对象编程风格 2014-07-13 4.1 如何实现一个class 4.2 什么是Constructors(构造函数)和Destructor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZmZN4.html" rel="bookmark" class="title">&period;NET 控制Windows文件和目录访问权限研究（FileSystemAccessRule）</a>
					<div>
						前一段时间学习了.net 控制windows文件和目录权限的相关内容,期间做了一些总结.想把这方面的研究跟大家分享,一起学习.其中不免得有些用词不太标准的地方,希望大家留言指正留言,我加以修改. 首先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q7XYB0.html" rel="bookmark" class="title">c&plus;&plus;操作io常见命令</a>
					<div>
						用c++练习下 系统常见io命令. 1)显示文档的文本 2)统计文本单词数字 3)列出目录所有文件 ,递归思路 4)查找第一个匹配的字符. 5)文本单词排序, 快速排序,其实还是递归思路 6)文本单词 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbd7b3.html" rel="bookmark" class="title">匿名与闭包函数</a>
					<div>
						一.匿名函数写法  最常见的用法: (function() {   alert('water');})(); 当然也可以带参数: (function(o) {     alert(o); })('wa ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
